//----  script file, WarFactory - 15
// AUTHORS:  	Slade & Filthy Clyde
// Code stolen happily from Dolf Kooz Maps

// 15 - delete more globals

//===========================================




$OVconvoyTech = 1;

$server::TeamDamage = False;

$actionStarted = false;

$maxRange = 2500;
$minRange = 500;

// how many player are alive at squad drop time
$numLivePlayers = 0;

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------
   
Pilot backupPilot
{
   id = 29;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.8;
   activateDist = 11000.0;
   deactivateBuff = 12000.0;
   targetFreq = 3.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.2;
   orderFreq = 1.5;
};
   

function onMissionLoad()
{


   cdAudioCycle("Purge", "Watching", "Mechsoul"); 

    $textMsg = "Mission Credits:  Slade & Filthy Clyde.  "@
      "Objectives:   "@
    "Destroy Cybrid Outposts, Destroy Cybrid War Factory, "@
      "Extraction at Nav Bravo.  "@
   "Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";
   %history = 
"\n\nDate: 2831. Listen up guys.  We heard a rumor of a Cybrid War Factory "@
"built in the Yukon Wilderness.  We don't know exactly where it is.  We think"@
" it is East of your position.  We are dropping you in"@
" by pod.  Link up with your squad, look for the factory and destroy it along"@
"  with anything else you find.   Be careful.";

//We are testing the Weapons Booster we just got."@
//"  All your weapons systems are stronger.   Your vehicles have been equipped with The "@
//"  Kiss Of Death.   One side effect is radiation.  Be careful.";



   setGameInfo ($textMsg @ %history);
}


//--------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);

   marsSounds();
   windSounds();
   init();

}

//---------------------------------------------
function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");

}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

// messagebox (%player, "Check the game info tab for game details");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }


//---------------------------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);
              Say(%player,0,"<F5>TAC-COM HERE:  Brids everywhere.   We saw some outposts East of you.  The War Factory must be here somewhere.....  It's like an anthill....");

       }
   }

}

//-----------------Use to rotate Navpoints---------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}
//-----------------------------------------------------------------------------
function init()
{

$objective1 = false;
$objective2 = false;
$objective3 = false;
$objective4 = false;
$objective5 = false;
$objective6 = false;
$objective7 = false;
$objective8 = false;
$objective9 = false;

   $attackStarted = false;

   $Baddies = false;


$buildingsDestroyed = 0;

$navAlpha = "MissionGroup/navPoints/navAlpha";
$navBravo = "MissionGroup/navPoints/navBravo";
   MPcheckBoundary( leave, getObjectID ($navAlpha) , 250, onLeaveNavAlphaWarning, 1 );
}



//-----------------------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{
//------Base1 Stuff--------
	if (%this == getObjectId( "MissionGroup/Base1/Cgen1" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
//        createbackup();
//        createbackup();
      $objective1 = true;
	}
//------Base2 Stuff------
	if (%this == getObjectId( "MissionGroup/Base2/Cgen2" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
//        createbackup();
//        createbackup();
      $objective2 = true;
	}
//------Base3 Stuff--------
	if (%this == getObjectId( "MissionGroup/Base3/Cgen3" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
//        createbackup();
//        createbackup();
      $objective3 = true;
	}
//------Base4 Stuff--------
	if (%this == getObjectId( "MissionGroup/Base4/Cgen4" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
//        createbackup();
//        createbackup();
      $objective4 = true;
	}
//------Base5 Stuff------
	if (%this == getObjectId( "MissionGroup/Base5/Cgen5" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
        createbackup();
//        createbackup();
      $objective5 = true;
	}
//------Base6 Stuff--------
	if (%this == getObjectId( "MissionGroup/Base6/Cgen6" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
//        createbackup();
//        createbackup();
      $objective6 = true;
	}
//------Base7 Stuff--------
	if (%this == getObjectId( "MissionGroup/Base7/Cgen7" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
        createbackup();
//        createbackup();
      $objective7 = true;
	}
//------Base8 Stuff------
	if (%this == getObjectId( "MissionGroup/Base8/Cgen8" ) )
	{
	say(0, 0, "<F5>Cybrid Outpost Destroyed");
        createbackup();
//        createbackup();
      $objective8 = true;
	}

//------Base9 Stuff---------
	if (%this == getObjectId( "MissionGroup/Base9/Cgen9" ) )
	{
	say(0, 0, "<F5>Cybrid War Factory Destroyed, extraction at Bravo");
        createbackup();
//        createbackup();
        setNavBravoON();
      $objective9 = true;
       createDropShip();


   schedule( "say(0, 0, \"<F5>DROPSHIP PILOT:  Here at Nav Bravo and ready for pickup.\");", 30 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP PILOT:  Under attack.  Shields holding.  Get here when you can.\");", 60 );     

   schedule( "$Baddies = false;", 10 );    

   schedule( "winCondition();", 210 );     
       MPcheckBoundary( enter, getObjectID ($navBravo) , 250, onArriveNavBravo, 20 );
	}

}

//-----------------------------------------------------------------------------
function onArriveNavBravo()
{

 %obj1 = getObjectID ( $navBravo );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavBravo();", 10 );
    }

}


//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }




  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }

}



//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %nums = 0;

  if ( $objective1 == true )
    {
     %nums++;
    }
  if ( $objective2 == true )
    {
     %nums++;
    }
  if ( $objective3 == true )
    {
     %nums++;
    }
  if ( $objective4 == true )
    {
     %nums++;
    }
  if ( $objective5 == true )
    {
     %nums++;
    }
  if ( $objective6 == true )
    {
     %nums++;
    }
  if ( $objective7 == true )
    {
     %nums++;
    }
  if ( $objective8 == true )
    {
     %nums++;
    }
  if ( $objective9 == true )
    {
     %nums++;
    }

  if ( %nums == 9 )
    {
     %text = "All Cybrid Outposts & Cybrid War Factory Destroyed.  Excellent work team.";
    }

  if ( %nums < 9 )
    {
     %text = "Mission Failed, Some Cybrid Outposts Remaining";
    }
  
  messageBox(0, "Mission Over, " @ %nums @ " of 9 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($objective4);
  deleteVariables($objective5);
  deleteVariables($objective6);
  deleteVariables($objective7);
  deleteVariables($objective8);
  deleteVariables($objective9);
  deleteVariables($hercD);
  deleteVariables($Baddies);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavBravoON");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("onArriveNavBravo");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("createDropShip");
   deleteFunctions("onLeaveNavAlphaWarning");
   deleteFunctions("vehicle::onMessage");
   deleteFunctions("placeObject");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("structure::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("springHigh::trigger::onenter");
   deleteFunctions("loop");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionendconditionmet();
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($objective4);
  deleteVariables($objective5);
  deleteVariables($objective6);
  deleteVariables($objective7);
  deleteVariables($objective8);
  deleteVariables($objective9);
  deleteVariables($hercD);
  deleteVariables($Baddies);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavBravoON");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("onArriveNavBravo");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("createDropShip");
   deleteFunctions("onLeaveNavAlphaWarning");
   deleteFunctions("vehicle::onMessage");
   deleteFunctions("placeObject");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("structure::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("springHigh::trigger::onenter");
   deleteFunctions("loop");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

   missionendconditionmet();
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function createDropShip()
{
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,28);

  setPosition ($hercD, -1645.00, 1093.00, 28.00 );

// don't let that ship take off!
   order( $hercD, shutdown, True );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onLeaveNavAlphaWarning ()
{

   $actionStarted = true;
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
   say (0,0, "<f5>TAC-COM:  We saw Eight outposts from the air on the way in, East of your position.  Take them out.");
//   schedule( "say(0, 0, \"<F5>TAC-COM:  We used the Weapons Booster we found.  Your weapons are boosted.  Your Hercs are equipped with the Kiss-Of-Death.\");", 20 );     
   schedule( "say(0, 0, \"<F5>TAC-COM:  Your Hercs have the new MedPak.  Scan your Squad to heal and reload them.\");", 30 );     

   $attackStarted = true;
   createbackup();
   createbackup();
//   createbackup();

   $Baddies = true;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

// have the enemy pick a new target
// attacker can run into buildings
  %who1 = playerManager::vehicleIdToPlayerNum (%this);
  if ( %who1 != 0 ) return;

   %target = pickPlayer ();

   order (%this, attack, %target);
}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 40, %rot);

}

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;

//	if (%t == 1) return "C";
//	if (%t == 2) return "H";
	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{
   if ( $Baddies == true )
     {

 $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navBravo), 3, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 5 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 7 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 9 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 11 );
//     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 13 );
//     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 15 );
//     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 17 );

     }
}

function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{

   if ( $Baddies == true )
 {



 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 50 ;
      %y = %y + 50 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);


          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );

    }

 }
}




//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particluar reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}

//-------------------------------------------------------------
function vehicle::onAttacked ( %this, %who )
{




//----------------allow DS to heal------------------------------------------------

     if (%this ==  $hercD )
     {
       healobject ( %this, 5000 );
     }
}


//-----------------------Particle Accelerator from Raven---------------------

function springHigh::trigger::onenter(%this,%object)
{
   %player = playermanager::vehicleidtoplayernum(%object);
   if((getVehicleName(%object)!="Avenger") && (getVehicleName(%object)!="Bolo") && (getVehicleName(%object)!="Disrupter") && (getVehicleName(%object)!="Dreadlock") && (getVehicleName(%object)!="Harabec's Predator") && (getVehicleName(%object)!="Knight's Disruptor") && (getVehicleName(%object)!="Knight's Myrmidon") && (getVehicleName(%object)!="Knight's Paladin") && (getVehicleName(%object)!="Myrmidon") && (getVehicleName(%object)!="Paladin") && (getVehicleName(%object)!="Recluse") && (getVehicleName(%object)!="Avenger"))
   {
      %num = randomInt(225,250);
      loop(%player,%num);
      healobject ( %object, 5000 );
      healobject ( %object, 5000 );
//      healobject ( %object, 5000 );
      reloadObject ( %object, 5000 );
      reloadObject ( %object, 5000 );
//      reloadObject ( %object, 5000 );
      playsound(%player,"sfx_electrical_bzzt.wav",IDPRF_2D);
      playsound(%player,"sfx_steam.wav",IDPRF_2D);
      playsound(%player,"sfx_shrk.wav",IDPRF_2D);
   }
   else
   {
      say(%player,%player,"<f5>Your vehicle is not able to use the Particle Accelerators due to structural differences.");
   }
}
//------------------------------------------------------------------------------
function loop(%player,%num)
{
//   if((%num > 0)&&(%player.alive==true))
   if(%num > 0)
   {
      %num--;
      %vehicleId = playermanager::playernumtovehicleid(%player);
      damageArea(%vehicleId,0,0,0,10,0);
      schedule("loop(" @ %player @ "," @ %num @ ");",0.10);
   }
}
//------------------------------------------------------------------------------

//-------------------MedPak---------------------------------------------

function vehicle::onScan(%scanned,%scanner)	
{
   if ((%scanned != %scanner) &&
      (getTeam(%scanned) == getTeam(%scanner)) &&
      (getTeam(%scanned) == *IDSTR_TEAM_YELLOW))
       {
        healobject (%scanned, 2500 );
        reloadObject (%scanned, 2500 );
        %player1 = playerManager::vehicleIdToPlayerNum(%scanned);
        say ( %player1,1,"<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);

        %player2 = playerManager::vehicleIdToPlayerNum(%scanner);
        say ( %player2,1, "<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
       }
}
//------------------MedPak----------------------------------------------



//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------

//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------

//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------

//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------

//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------

//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------















































